## snek 1.4.1

=== Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_NO_BUILD_TARGETS = 1
SNEK_ROOT = .

include snek-install.defs

SNEK_OTHEROS?=0
ifeq ($(SNEK_OTHEROS),1)
SNEK_OTHEROS_DIR=$(SNEK_HOSTS)/linux $(SNEK_HOSTS)/windows $(SNEK_HOSTS)/macosx $(SNEK_HOSTS)/zip
endif

SUBDIRS = snekde doc examples $(SNEK_OTHEROS_DIR)

SNEKS = $(SNEK_PORTS)/posix/snek $(FIRMWARE)

all: $(SNEKS)
	+for dir in $(SUBDIRS); do (cd $$dir && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR)) || exit 1; done

$(SNEKS): FORCE
	+cd `dirname $@` && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR)

FORCE:

check: all
	+cd test && make $@
	+black --check --exclude 'fail-syntax-.*\.py|.*/hosts/.*.py' .

install:
	+for dir in $(SUBDIRS); do (cd $$dir && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR) $@) || exit 1; done
	+for snek in $(SNEKS); do (cd `dirname $$snek` && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR) $@) || exit 1; done

upload: $(SNEKS)
	+cd doc && make upload
	+for otheros in $(SNEK_OTHEROS_DIR); do (cd "$$otheros" && make upload); done

otheros: $(SNEKS)
	+cd doc && make
	+for otheros in $(SNEK_OTHEROS_DIR); do (cd "$$otheros" && make); done

snek-mu.py:
	find . -name '*.builtin' -print0 | xargs -0 python3 ./snek-builtin.py --mu -o $@

docker:
	docker build -t phsilva/snek .

clean:
	+for dir in $(SUBDIRS); do (cd $$dir && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR) $@); done
	+for snek in $(SNEKS); do (cd `dirname $$snek` && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR) $@); done

=== test/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT=..

include $(SNEK_ROOT)/snek.defs

PYTHON3?=python3
SNEK_NATIVE?=$(SNEK_PORTS)/posix/snek
ifdef SNEK_RISCV_TEST
SNEK_RISCV?=$(SNEK_PORTS)/qemu-riscv/snek-riscv
else
SNEK_RISCV=
endif
SNEK_ARM?=$(SNEK_PORTS)/qemu-arm/snek-arm

LANGS=python3 $(SNEK_NATIVE) $(SNEK_ARM) $(SNEK_RISCV)

SUCCESS_TESTS = \
	pass-andor.py \
	pass-list.py \
	pass-dict.py \
	pass-equal_is.py \
	pass-float.py \
	pass-for-array.py \
	pass-for-range.py \
	pass-for-string.py \
	pass-for-break.py \
	pass-for-nested.py \
	pass-global.py \
	pass-if.py \
	pass-int.py \
	pass-math.py \
	pass-op.py \
	pass-range.py \
	pass-slice.py \
	pass-while.py \
	pass-while-break.py \
	pass-while-else.py \
	pass-scoping-global.py \
	pass-scoping-local.py \
	pass-none.py \
	pass-args.py \
	pass-assert-success.py \
	pass-interpolate-list.py \
	pass-get.py \
	pass-interpolate-str.py \
	pass-trailing-comma.py

SYNTAX_TESTS = \
	fail-syntax-lex-bang.py \
	fail-syntax-list-named.py \
	fail-syntax-tuple-named.py

FAIL_TESTS = \
	fail-scoping-no-decl.py \
	fail-range-named.py \
	fail-formal-named-first.py \
	fail-actual-named-first.py \
	fail-args-missing.py \
	fail-arg-dup1.py \
	fail-arg-dup2.py \
	fail-arg-unknown.py \
	fail-assert-fail.py \
	fail-interpolate-missing.py \
	fail-interpolate-extra.py \
	fail-interpolate-badformat.py \
	fail-dictionary-mutable.py \
	$(SYNTAX_TESTS)

check:
	@exit=0; \
	for TEST in $(SUCCESS_TESTS); do \
		echo "Running test $$TEST."; \
		for lang in $(LANGS); do \
			baselang=`basename $$lang`; \
			if $$lang $$TEST; then \
				echo "    pass $$baselang"; \
			else \
				echo "    ***************** $$baselang fail *********************"; \
				exit=1;\
			fi; \
		done; \
	done; \
	for TEST in $(FAIL_TESTS); do \
		echo "Running test $$TEST."; \
		for lang in $(LANGS); do \
			baselang=`basename $$lang`; \
			$$lang $$TEST >/dev/null 2>&1; \
			if [ $$? -eq 1 ]; then \
				echo "    pass $$baselang"; \
			else \
				echo "    ***************** $$baselang fail *********************"; \
				exit=1;\
			fi; \
		done; \
	done; \
	exit $$exit

=== hosts/linux/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT=../..

SNEK_NO_BUILD_TARGETS = 1

include $(SNEK_ROOT)/snek-install.defs

LINUX_DIST=snek-linux-$(SNEK_VERSION).tar.bz2
LINUX_SH=snek-linux-$(SNEK_VERSION).sh
DESKTOP_FILES=$(SNEK_PORTS)/posix/snek.desktop.in $(SNEK_ROOT)/snekde/snekde.desktop.in

PROGS= \
	$(SNEK_PORTS)/posix/snek \
	$(SNEK_ROOT)/snekde/snekde \
	$(SNEK_PORTS)/duemilanove/snek-duemilanove-install.in \
	$(SNEK_PORTS)/itsybitsy5v/snek-itsybitsy-install.in \
	$(SNEK_PORTS)/mega/snek-mega-install.in

EXAMPLES=$(SNEK_ROOT)/examples

ICONS=$(SNEK_ROOT)/snek.svg

DOC= \
	$(PDF) \
	$(SNEK_ROOT)/snekde/snekde.1 \
	$(SNEK_ROOT)/COPYING \
	$(SNEK_PORTS)/duemilanove/snek-duemilanove-install.1 \
	$(SNEK_PORTS)/itsybitsy5v/snek-itsybitsy-install.1 \
	$(SNEK_PORTS)/mega/snek-mega-install.1

LINUX_FILES=$(PROGS) $(DESKTOP_FILES) $(FIRMWARE) $(USBFIRMWARE) $(ICONS) $(DOC) $(EXAMPLES)

all: $(LINUX_SH)

$(LINUX_SH): $(LINUX_DIST) linux-install.sh
	cat linux-install.sh $(LINUX_DIST) > $@
	chmod +x $@

linux-install.sh: linux-install.sh.in
	$(SNEK_SED) $^ > $@

$(LINUX_DIST): $(LINUX_FILES) $(LINUX_EXTRA)
	-rm -f $@
	-rm -rf linux
	mkdir -p linux/Snek
	cp -a $(LINUX_FILES) linux/Snek
	tar cjf $@ -C linux Snek

install:
	echo install done

upload: $(LINUX_SH)
	rsync -avz $(LINUX_SH) $(SNEKDIST)

clean:
	rm -f snek-*.sh *.bz2
	rm -rf linux

=== hosts/macosx/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_NO_BUILD_TARGETS = 1
SNEK_ROOT=../..

include $(SNEK_ROOT)/snek-install.defs

MACOSX_RES=16 32 128 256 512
MACOSX_ICON_PNGS = $(shell for i in $(MACOSX_RES); do echo snek-$$i.png; done)
MACOSX_ICON = snek.icns
MACOSX_DIST = snek-mac-$(SNEK_VERSION).dmg

SNEKDE = $(SNEK_ROOT)/snekde/snekde.py
SNEKDE_SCRIPTS = runsnekde snekde-script
SNEKDE_FILES = $(SNEKDE_SCRIPTS) snekde-Info.plist $(SNEKDE)

ifneq ($(strip $(SNEKMAC)),)
SNEK = snek
SNEK_SCRIPTS =  runsnek snek-script
SNEK_FILES = $(SNEK_SCRIPTS) snek-Info.plist $(SNEK)
endif

MACOSX_INSTALL = install-macosx

MACOSX_DOCS = $(PDF) $(SNEK_ROOT)/COPYING ReadMe-Mac.rtf

MACOSX_FILES=$(SNEKDE_FILES) $(SNEK_FILES) serial $(MACOSX_ICON) $(MACOSX_SCRIPTS) $(MACOSX_INSTALL) $(MACOSX_DOCS) $(SNEK_ROOT)/examples/*.py

all: $(MACOSX_DIST)

$(MACOSX_ICON): $(SNEK_ROOT)/snek.svg
	for i in $(MACOSX_RES); do rsvg-convert -w $$i -h $$i -o snek-$$i.png $^; done
	png2icns $@ $(MACOSX_ICON_PNGS)

macosx: $(MACOSX_FILES)
	rm -rf macosx
	mkdir -p macosx/examples

ifeq ($(strip $(SNEKMAC)),)
snek-bits:
	echo 'no snek app'
else
snek-bits: $(SNEK_FILES) macosx
	#
	# snek
	#
	mkdir -p macosx/snek.app/Contents/Resources macosx/snek.app/Contents/MacOS
	echo 'APPLSN.O' > macosx/snek.app/Contents/PkgInfo
	cp -p snek-Info.plist macosx/snek.app/Contents/Info.plist
	cp -p $(MACOSX_ICON) macosx/snek.app/Contents/Resources
	cp -a $(SNEK) macosx/snek.app/Contents/Resources
	cp -p $(SNEK_SCRIPTS) macosx/snek.app/Contents/MacOS/
endif

$(MACOSX_DIST): $(MACOSX_FILES) macosx snek-bits
	rm -f $@
	cp -a $(MACOSX_DOCS) macosx
	cp -a $(MACOSX_INSTALL) macosx
	cp -a $(FIRMWARE) macosx
	cp -a $(USBFIRMWARE) macosx
	cp -a $(SNEK_ROOT)/examples/* macosx/examples
	#
	# snekde
	#
	mkdir -p macosx/snekde.app/Contents/Resources macosx/snekde.app/Contents/MacOS
	echo 'APPLSN.O' > macosx/snekde.app/Contents/PkgInfo
	cp -p snekde-Info.plist macosx/snekde.app/Contents/Info.plist
	cp -p $(MACOSX_ICON) macosx/snekde.app/Contents/Resources
	cp -a $(SNEKDE) macosx/snekde.app/Contents/Resources
	cp -a serial macosx/snekde.app/Contents/Resources
	cp -p $(SNEKDE_SCRIPTS) macosx/snekde.app/Contents/MacOS/
	#
	# generate iso image
	#
	genisoimage -D -V Snek-$(SNEK_VERSION) -no-pad -r -apple -o $@ macosx

serial: always
	rsync -a --delete --delete-excluded --exclude '__pycache__' --exclude '*.pyc' /usr/lib/python3/dist-packages/serial/ serial

always:

snekde-Info.plist: snekde-Info.plist.in
	$(SNEK_SED) $^ > $@

snek-Info.plist: snek-Info.plist.in
	$(SNEK_SED) $^ > $@

$(SNEK): FORCE
	./build-mac $(SNEKMAC) $@

FORCE:

install:
	echo install done

upload: $(MACOSX_DIST)
	rsync -avz $(MACOSX_DIST) $(SNEKDIST)

clean:
	rm -rf serial
	rm -rf snek
	rm -f $(MACOSX_ICON) $(MACOSX_ICON_PNGS)
	rm -f snekde-Info.plist snek-Info.plist
	rm -rf macosx *.dmg

=== hosts/windows/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT=../..

SNEK_LOCAL_SRC = \
	snek-windows.c \
	$(SNEK_ROOT)/snek-math.c

SNEK_LOCAL_INC = snek-windows.h
SNEK_LOCAL_BUILTINS = snek-windows.builtin $(SNEK_ROOT)/snek-math.builtin

INF=altusmetrum.inf
WINDOWS_FILES=snek.exe snek.ico snekde.py $(PDF) $(SNEK_ROOT)/examples $(SNEK_ROOT)/COPYING $(FIRMWARE) $(USBFIRMWARE) $(INF)

include $(SNEK_ROOT)/snek-install.defs

WINDOWS_INSTALL=build/nsis/snek-windows-$(SNEK_VERSION_DASH).exe

CC=i686-w64-mingw32-gcc
MINGFLAGS=-Wall -Wextra -mconsole

OPT=-O0

CFLAGS=$(OPT) -g -I. $(SNEK_CFLAGS) $(MINGFLAGS)

LIBS=-lm

all: $(WINDOWS_INSTALL)

$(WINDOWS_INSTALL): $(WINDOWS_FILES) snek.cfg
	pynsist snek.cfg

snek.cfg: snek.cfg.in $(SNEK_ROOT)/snek-install.defs $(SNEK_ROOT)/snek.defs
	for i in $(FIRMWARE); do echo "	$$i"; done | sed '/@SNEK_FIRMWARE@/r /dev/stdin' snek.cfg.in | sed '/@SNEK_FIRMWARE/d' | $(SNEK_SED) > $@

snek.exe: $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $(SNEK_OBJ) $(LIBS)

vpath %.svg $(SNEK_ROOT)

snekde.py: $(SNEK_ROOT)/snekde/snekde.py
	cp $^ $@

.SUFFIXES: .svg .build .icns .ico .rc .o .exe

.svg.build:
	for i in $(RES); do rsvg-convert -w $$i -h $$i -o $*-$$i.png $^ || exit 1; done && touch $@

.build.ico:
	icotool -c -o $@ $(shell for i in $(RES); do echo $*-$$i.png; done)

.ico.rc:
	./make-rc "$*" $(VERSION) > $@

RES=16 24 32 48 64 72 96 128 180 256

install:
	echo install done

upload: $(WINDOWS_INSTALL)
	rsync -avz $(WINDOWS_INSTALL) $(SNEKDIST)

clean::
	rm -f snek.exe snek.ico snekde.py snek.cfg snek-*.png
	rm -rf build

=== hosts/zip/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT=../..

SNEK_NO_BUILD_TARGETS = 1

include $(SNEK_ROOT)/snek-install.defs

ZIP_DIST=snek-$(SNEK_VERSION).zip

PROGS= \
	$(SNEK_ROOT)/snekde/snekde

EXAMPLES=$(SNEK_ROOT)/examples

ICONS=$(SNEK_ROOT)/snek.svg

DOC= \
	$(PDF) \
	$(SNEK_ROOT)/COPYING

ZIP_FILES=$(PROGS) $(FIRMWARE) $(USBFIRMWARE) $(ICONS) $(DOC) $(EXAMPLES)

all: $(ZIP_DIST)

$(ZIP_DIST): $(ZIP_FILES)
	-rm -f $@
	-rm -rf zip
	mkdir -p zip/snek
	cp -a $(ZIP_FILES) zip/snek
	cd zip && zip ../$@ -r snek

install:
	echo install done

upload: $(ZIP_DIST)
	rsync -avz $(ZIP_DIST) $(SNEKDIST)

clean:
	rm -f snek-*.zip
	rm -rf zip

=== ports/duemilanove/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..
SNEK_ATMEGA = $(SNEK_ROOT)/chips/atmega

include $(SNEK_ATMEGA)/snek-atmega.defs

SNEK_LOCAL_VPATH = $(SNEK_ATMEGA)

SNEK_LOCAL_SRC = \
	snek-pow.c \
	snek-duemilanove.c \
	$(SNEK_ATMEGA_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_ATMEGA_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_ATMEGA_BUILTINS) \
	snek-duemilanove.builtin

include $(SNEK_ROOT)/snek-install.defs

SNEK_CFLAGS = $(SNEK_MOST_WARNINGS) $(SNEK_BASE_CFLAGS)

BASE=snek-duemilanove-$(SNEK_VERSION)
ELF=$(BASE).elf
HEX=$(BASE).hex
MAP=$(BASE).map
CC=avr-gcc

OPT=-Os -frename-registers -funsigned-char -fno-jump-tables -mcall-prologues

CFLAGS=$(OPT) -DF_CPU=16000000UL -mmcu=atmega328p -I. -I$(SNEK_LOCAL_VPATH) -g $(SNEK_CFLAGS) -Waddr-space-convert
LDFLAGS=$(SNEK_LDFLAGS) \
	-Wl,-uvfprintf -lprintf_flt -lm \
	-Wl,--defsym -Wl,__TEXT_REGION_LENGTH__=0x7e00 \
	-Wl,--defsym -Wl,__DATA_REGION_LENGTH__=0x7a0 \
	-Wl,--defsym -Wl,__EEPROM_REGION_LENGTH__=0x400 \
	-Wl,-Map=$(MAP)

ISP = usbtiny
#ISP = avrisp2

#
# lfuse: 0xff
#	CKDIV8:		1	no divide by 8
#	CKOUT:		1	no clock output
#	SUT1:		1	crystal osc, slow startup
#	SUT0:		1	crystal osc, slow startup
#	CKSEL3:		1	low swing osc, 8-16MHz
#	CKSEL2:		1	low swing osc, 8-16MHz
#	CKSEL1:		1	low swing osc, 8-16MHz
#	CKSEL0:		1	crystal osc
# hfuse:
#	RSTDISBL:	1	reset enabled
#	DWEN:		1	debug wire disabled
#	SPIEN:		0	SPI program enabled
#	WDTON:		1	watch dog disabled
#	EESAVE:		0	EEPROM saved across chip erase
#	BOOTSZ1:	1	256 words
#	BOOTSZ0:	1	256 words
#	BOOTRST:	1	boot to address 0
# efuse:
#	BODLEVEL2	1	brown out 2.5-2.9V
#	BODLEVEL1	0	brown out 2.5-2.9V
#	BODLEVEL0	1	brown out 2.5-2.9V

all: $(HEX) snek-duemilanove-install

$(HEX): $(ELF)
	avr-objcopy -O ihex -R .eeprom $^ $@

$(ELF): $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)
	@gawk '/__data_load_end/{printf("ROM used: %d bytes\n", strtonum($$1)); }' $(MAP)

snek-duemilanove-install: snek-duemilanove-install.in
	$(SNEK_SED) $^ > $@
	chmod +x $@

set-fuse:
	avrdude -F -V -c $(ISP) -p ATMEGA328P -U lfuse:w:0xff:m
	avrdude -F -V -c $(ISP) -p ATMEGA328P -U hfuse:w:0xd7:m
	avrdude -F -V -c $(ISP) -p ATMEGA328P -U efuse:w:0xfd:m

load: $(HEX) snek-duemilanove-install
	./snek-duemilanove-install -isp $(ISP) -hex $(HEX) load

install: snek-duemilanove-install $(HEX) snek-duemilanove-install.1
	install -d $(DESTDIR)$(BINDIR)
	install snek-duemilanove-install $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(HEX) $(DESTDIR)$(SHAREDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install -m 0644 snek-duemilanove-install.1 $(DESTDIR)$(MANDIR)/man1

clean::
	rm -f *.elf *.hex *.map snek-duemilanove-install

=== ports/playground/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..

SNEK_SAMD21 = $(SNEK_ROOT)/chips/samd21

PROGNAME=snek-playground
PRODUCT_NAME=SnekPlayground
IDPRODUCT=0x8018
IDVENDOR=0x239A

include $(SNEK_SAMD21)/snek-samd21.defs

SNEK_LOCAL_SRC = \
	snek-temperature.c \
	$(SNEK_SAMD21_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_SAMD21_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_SAMD21_BUILTINS) \
	snek-temperature.builtin \
	snek-playground.builtin

include $(SNEK_ROOT)/snek-install.defs

SRC=$(SNEK_SRC)
OBJ=$(SRC:.c=.o)

all: $(ELF) $(BIN) $(UF2)

$(PROG): Makefile $(OBJ)
	$(call quiet,CC) $(LDFLAGS) -Wl,-M=$(MAP) -o $@ $(OBJ) $(LIBS)

$(OBJ): $(SNEK_INC)

distclean:	clean

clean::
	rm -f *.o *.elf *.bin *.uf2 *.map ao-product.h

install: $(UF2)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(UF2) $(DESTDIR)$(SHAREDIR)

uninstall:

=== ports/posix/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT=../..

SNEK_LOCAL_SRC = \
	snek-main.c \
	snek-posix.c \
	snek-math.c \
	snek-curses.c \
	snek-input.c

SNEK_LOCAL_INC = snek-posix.h
SNEK_LOCAL_CFLAGS = 
SNEK_LOCAL_BUILTINS = snek-posix.builtin $(SNEK_ROOT)/snek-math.builtin $(SNEK_ROOT)/snek-input.builtin

include $(SNEK_ROOT)/snek-install.defs

OPT?=-O3

CFLAGS+=-DSNEK_MEM_INCLUDE_NAME $(OPT) -g -I. $(SNEK_CFLAGS) -Werror $(CPPFLAGS) $(CFLAGS_POSIX)

LIBS=-lreadline -lm

all: snek snek.desktop

snek: $(SNEK_OBJ)
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $(SNEK_OBJ) $(LIBS)

install: snek snek.desktop snek.1
	install -d $(DESTDIR)$(BINDIR)
	install snek $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(APPDIR)
	install snek.desktop $(DESTDIR)$(APPDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install snek.1 $(DESTDIR)$(MANDIR)/man1

snek.desktop: snek.desktop.in
	$(SNEK_SED) $^ > $@

clean::
	rm -f snek snek.desktop

=== ports/qemu-arm/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..

SNEK_QEMU = $(SNEK_ROOT)/chips/qemu

ARCH = arm-none-eabi
ARCH_CFLAGS = -mlittle-endian -mcpu=cortex-m3 -mthumb 
PROGNAME = snek-qemu-arm

include $(SNEK_QEMU)/snek-qemu.defs

include $(SNEK_ROOT)/snek-install.defs

SRC=$(SNEK_SRC)
OBJ=$(SRC:.c=.o)

all: $(PROG) snek-arm

$(PROG): Makefile $(OBJ)
	$(call quiet,CC) $(LDFLAGS) -Wl,-Tsnek-qemu-arm.ld -Wl,-M=$(MAP) -o $@ $(OBJ) $(LIBS)

$(OBJ): $(SNEK_INC)

install: $(PROG) snek-arm
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(PROG) $(DESTDIR)$(SHAREDIR)
	install -m 0755 snek-arm $(DESTDIR)$(SHAREDIR)

snek-arm: snek-arm.in
	$(SNEK_SED) $^ > $@
	chmod +x $@

uninstall:

clean::
	rm -f run-arm

=== ports/qemu-riscv/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..

SNEK_QEMU = $(SNEK_ROOT)/chips/qemu

ARCH = riscv64-unknown-elf
ARCH_CFLAGS = -march=rv32imac -mabi=ilp32 -msave-restore
PROGNAME = snek-qemu-riscv

include $(SNEK_QEMU)/snek-qemu.defs

include $(SNEK_ROOT)/snek-install.defs

SRC=$(SNEK_SRC)
OBJ=$(SRC:.c=.o)

all: $(PROG) snek-riscv

$(PROG): Makefile $(OBJ)
	$(call quiet,CC) $(LDFLAGS) -Wl,-Tsnek-qemu-riscv.ld -Wl,-M=$(MAP) -o $@ $(OBJ) $(LIBS)

$(OBJ): $(SNEK_INC)

snek-riscv: snek-riscv.in
	$(SNEK_SED) $^ > $@
	chmod +x $@

install: $(PROG) snek-riscv
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(PROG) $(DESTDIR)$(SHAREDIR)
	install snek-riscv $(DESTDIR)$(SHAREDIR)

uninstall:

=== debian/changelog ===
snek (1.4.1-6) unstable; urgency=medium

  * Add gcc as autopkgtest dependency

 -- Keith Packard <keithp@keithp.com>  Sat, 23 May 2020 19:41:39 -0700

snek (1.4.1-5) unstable; urgency=medium

  * Require fewer dependencies for -arch packages
  * Don't test risc-v binaries as QEMU doesn't support that yet

 -- Keith Packard <keithp@keithp.com>  Sat, 23 May 2020 09:13:34 -0700

snek (1.4.1-4) unstable; urgency=medium

  * Add dependency from snek-bin to snek to get desktop icon
  * Add -fdebug-prefix-map to builds

 -- Keith Packard <keithp@keithp.com>  Fri, 22 May 2020 16:40:31 -0700

snek (1.4.1-3) unstable; urgency=medium

  * Move qemu-system-arm to Build-Depends-Indep

 -- Keith Packard <keithp@keithp.com>  Fri, 22 May 2020 15:12:38 -0700

snek (1.4.1-2) unstable; urgency=medium

  * Split out Build-Depends-Indep so -arch builds don't pull in toolchains

 -- Keith Packard <keithp@keithp.com>  Fri, 22 May 2020 14:44:14 -0700

snek (1.4.1-1) unstable; urgency=medium

  * Bug fix for string compare on aarch64
  * Fix snek-duemilanove-install man page bug
  * Fail dictionary creation with mutable key

 -- Keith Packard <keithp@keithp.com>  Fri, 22 May 2020 12:42:12 -0700

=== debian/control ===
Source: snek
Section: interpreters
Priority: optional
Maintainer: Keith Packard <keithp@keithp.com>
Homepage: https://keithp.com
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13), libreadline-dev, python3, lola, gawk
Build-Depends-Indep: avr-libc, gcc-avr,
 binutils-arm-none-eabi, gcc-arm-none-eabi, picolibc-arm-none-eabi (>= 1.4), qemu-system-arm,
 binutils-riscv64-unknown-elf, gcc-riscv64-unknown-elf, picolibc-riscv64-unknown-elf (>= 1.4),
 gcc-arm-linux-gnueabi, libc6-dev-armel-cross,
 asciidoctor, ruby-asciidoctor-pdf, ruby-coderay,
 black
Standards-Version: 4.5.0

Package: snek
Architecture: all
Suggests: snek-bin
Depends: ${misc:Depends}, python3, python3-serial, usbutils
Description: Embedded system programming language
 Snek is a small python-like language designed for embedded
 computers. It can run on systems as small as an Arduino Duemilanove
 board, which is an ATmega 328 processor with 32kB of flash and 2kB of
 ram. This package includes binaries and installation tools for many
 targets along with the snekde integrated development environment.

Package: snek-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, snek
Description: Host binary version of Snek programming language
 Snek is a small python-like language designed for embedded
 computers. It can run on systems as small as an Arduino Duemilanove
 board, which is an ATmega 328 processor with 32kB of flash and 2kB of
 ram. This package provides a host snek binary for playing with the
 language on your host machine.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export SNEK_OTHEROS=0
export PREFIX=/usr
export CFLAGS_POSIX=$(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get LDFLAGS)
export V=1

BUILDDIR = $(shell pwd)

SNEK_MOST_WARNINGS =  \
	-fdebug-prefix-map=$(BUILDDIR)=. \
	-Wall \
	-Wcast-align \
	-Wextra \
	-Wpointer-arith \
	-Wstrict-prototypes \
	-Wmissing-prototypes \
	-Wmissing-declarations \
	-Wnested-externs \
	-Wshadow

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_strip:
	dh_strip -X.elf -Xsnek-ev3

override_dh_dwz:
	dh_dwz -X.elf -Xsnek-ev3

override_dh_shlibdeps:
	dh_shlibdeps -X.elf -Xsnek-ev3

override_dh_auto_build-indep:
	dh_auto_build -- "SNEK_MOST_WARNINGS=$(SNEK_MOST_WARNINGS)"

override_dh_auto_build-arch:
	dh_auto_build -- -C ports/posix SUBDIRS= FIRMWARE= "SNEK_MOST_WARNINGS=$(SNEK_MOST_WARNINGS)"

override_dh_auto_test-arch:
	dh_auto_test -- -C test FIRMWARE= SNEK_RISCV= SNEK_ARM=

override_dh_auto_install-arch:
	dh_auto_install -- -C ports/posix

## snek 1.5

=== Makefile ===
--- 
+++ 
@@ -17,12 +17,9 @@
 
 include snek-install.defs
 
-SNEK_OTHEROS?=0
-ifeq ($(SNEK_OTHEROS),1)
 SNEK_OTHEROS_DIR=$(SNEK_HOSTS)/linux $(SNEK_HOSTS)/windows $(SNEK_HOSTS)/macosx $(SNEK_HOSTS)/zip
-endif
 
-SUBDIRS = snekde doc examples $(SNEK_OTHEROS_DIR)
+SUBDIRS = snekde doc examples
 
 SNEKS = $(SNEK_PORTS)/posix/snek $(FIRMWARE)
 
@@ -36,18 +33,22 @@
 
 check: all
 	+cd test && make $@
+
+black:
 	+black --check --exclude 'fail-syntax-.*\.py|.*/hosts/.*.py' .
 
-install:
+install: all
 	+for dir in $(SUBDIRS); do (cd $$dir && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR) $@) || exit 1; done
 	+for snek in $(SNEKS); do (cd `dirname $$snek` && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR) $@) || exit 1; done
 
-upload: $(SNEKS)
+upload: otheros
 	+cd doc && make upload
 	+for otheros in $(SNEK_OTHEROS_DIR); do (cd "$$otheros" && make upload); done
 
-otheros: $(SNEKS)
-	+cd doc && make
+install-otheros: otheros install
+	+for otheros in $(SNEK_OTHEROS_DIR); do (cd "$$otheros" && make install-otheros); done
+
+otheros: all
 	+for otheros in $(SNEK_OTHEROS_DIR); do (cd "$$otheros" && make); done
 
 snek-mu.py:

=== test/Makefile ===
--- 
+++ 
@@ -56,7 +56,8 @@
 	pass-interpolate-list.py \
 	pass-get.py \
 	pass-interpolate-str.py \
-	pass-trailing-comma.py
+	pass-trailing-comma.py \
+	pass-chain-op.py
 
 SYNTAX_TESTS = \
 	fail-syntax-lex-bang.py \

=== ports/crickit/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..

SNEK_SAMD21 = $(SNEK_ROOT)/chips/samd21

PROGNAME=snek-crickit
PRODUCT_NAME=SnekCrickit
IDPRODUCT=0x002c
IDVENDOR=0xfffe

include $(SNEK_SAMD21)/snek-samd21.defs

SNEK_LOCAL_SRC = \
	$(SNEK_SAMD21_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_SAMD21_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_SAMD21_BUILTINS) \
	snek-crickit.builtin

include $(SNEK_ROOT)/snek-install.defs

SRC=$(SNEK_SRC)
OBJ=$(SRC:.c=.o)

all: $(ELF) $(BIN) $(UF2)

$(PROG): Makefile $(OBJ)
	$(call quiet,CC) $(LDFLAGS) -Wl,-M=$(MAP) -o $@ $(OBJ) $(LIBS)

$(OBJ): $(SNEK_INC)

distclean:	clean

clean::
	rm -f *.o *.elf *.bin *.uf2 *.map ao-product.h

install: $(UF2)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(UF2) $(DESTDIR)$(SHAREDIR)

uninstall:

=== ports/duemilanove/Makefile ===
--- 
+++ 
@@ -21,7 +21,7 @@
 
 SNEK_LOCAL_SRC = \
 	snek-pow.c \
-	snek-duemilanove.c \
+	snek-328p.c \
 	$(SNEK_ATMEGA_SRC)
 
 SNEK_LOCAL_INC = \
@@ -29,7 +29,7 @@
 
 SNEK_LOCAL_BUILTINS = \
 	$(SNEK_ATMEGA_BUILTINS) \
-	snek-duemilanove.builtin
+	snek-328p.builtin
 
 include $(SNEK_ROOT)/snek-install.defs
 
@@ -47,7 +47,8 @@
 LDFLAGS=$(SNEK_LDFLAGS) \
 	-Wl,-uvfprintf -lprintf_flt -lm \
 	-Wl,--defsym -Wl,__TEXT_REGION_LENGTH__=0x7e00 \
-	-Wl,--defsym -Wl,__DATA_REGION_LENGTH__=0x7a0 \
+	-Wl,--defsym -Wl,__DATA_REGION_ORIGIN__=0x800100 \
+	-Wl,--defsym -Wl,__DATA_REGION_LENGTH__=0x780 \
 	-Wl,--defsym -Wl,__EEPROM_REGION_LENGTH__=0x400 \
 	-Wl,-Map=$(MAP)
 
@@ -97,7 +98,7 @@
 	avrdude -F -V -c $(ISP) -p ATMEGA328P -U efuse:w:0xfd:m
 
 load: $(HEX) snek-duemilanove-install
-	./snek-duemilanove-install -isp $(ISP) -hex $(HEX) load
+	./snek-duemilanove-install -hex $(HEX)
 
 install: snek-duemilanove-install $(HEX) snek-duemilanove-install.1
 	install -d $(DESTDIR)$(BINDIR)

=== ports/esp32/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..
include ../../snek-install.defs

ESP32_IDF ?= ./esp32-idf

TARGET=snek-esp32-$(SNEK_VERSION).bin
TARGET_DASH=snek-esp32-$(SNEK_VERSION_DASH).bin

all: $(TARGET)

$(TARGET): build/$(TARGET_DASH)
	cp $^ $@

build/$(TARGET_DASH):
	make -C main all
	SNEK_VERSION_DASH=$(SNEK_VERSION_DASH) $(ESP32_IDF) build

clean::
	$(ESP32_IDF) clean
	+make -C main clean

load:
	$(ESP32_IDF) -p /dev/ttyUSB1 flash

connect:
	minicom -D /dev/ttyUSB1 -b 115200

install: $(TARGET)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(TARGET) $(DESTDIR)$(SHAREDIR)

=== ports/ev3/Makefile ===
#
# Copyright © 2020 Mikhail Gusarov <dottedmag@dottedmag.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

vpath snek-posix.c ../posix

SNEK_ROOT=../..

CC=arm-linux-gnueabi-gcc
PROGNAME=snek-ev3
PROG=$(PROGNAME)-$(SNEK_VERSION)

SNEK_LOCAL_SRC = \
	snek-main.c \
	snek-posix.c \
	snek-math.c \
	snek-input.c \
	sensors.c \
	motors.c \
	utils.c

SNEK_LOCAL_INC = snek-ev3.h utils.h sensors.h motors.h
SNEK_LOCAL_CFLAGS = -DSNEK_USE_GLIBC_2_4_MATH
SNEK_LOCAL_BUILTINS = \
	snek-ev3.builtin \
	$(SNEK_ROOT)/snek-math.builtin \
	$(SNEK_ROOT)/snek-input.builtin

include $(SNEK_ROOT)/snek-install.defs

SNEK_CFLAGS = $(SNEK_MOST_WARNINGS) $(SNEK_BASE_CFLAGS)

OPT?=-O3

CFLAGS+=-DSNEK_MEM_INCLUDE_NAME $(OPT) -g -I. $(SNEK_CFLAGS) -Werror $(CPPFLAGS)

LIBS=-lm

all: $(PROG)

$(PROG): $(SNEK_OBJ)
	$(call quiet,CC) $(CFLAGS) $(LDFLAGS) -o $@ $(SNEK_OBJ) $(LIBS)

install: $(PROG)
	install -d $(DESTDIR)$(SHAREDIR)
	install $(PROG) $(DESTDIR)$(SHAREDIR)

clean::
	rm -f $(PROG)

=== ports/itsybitsy3v/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..
SNEK_AVR = $(SNEK_ROOT)/chips/avr

PROGNAME=snek-itsybitsy3v
PRODUCT_NAME=SnekItsyBitsy3v

AVR_CLOCK=8000000UL

include $(SNEK_AVR)/snek-avr.defs

SNEK_LOCAL_SRC = \
	$(SNEK_AVR_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_AVR_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_AVR_BUILTINS) \
	snek-itsybitsy3v.builtin

include $(SNEK_ROOT)/snek-install.defs

all: $(ELF) $(HEX)

$(PROG): Makefile $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $(SNEK_OBJ) $(LDFLAGS)
	@gawk '/__data_load_end/{printf("ROM used: %d bytes\n", strtonum($$1)); }' $(MAP)

$(SNEK_OBJ): $(SNEK_INC)

distclean: clean

clean::
	rm -f *.hex *.elf *.map
	rm -f ao-product.h

install: $(HEX)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(HEX) $(DESTDIR)$(SHAREDIR)

uninstall:

ISP=avrisp2

load: $(HEX) ../itsybitsy5v/snek-itsybitsy-install
	../itsybitsy5v/snek-itsybitsy-install -quick -isp $(ISP) -hex $(HEX) load

=== ports/itsybitsy5v/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..
SNEK_AVR = $(SNEK_ROOT)/chips/avr

PROGNAME=snek-itsybitsy5v
PRODUCT_NAME=SnekItsyBitsy5v

AVR_CLOCK=16000000UL

include $(SNEK_AVR)/snek-avr.defs

SNEK_LOCAL_SRC = \
	$(SNEK_AVR_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_AVR_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_AVR_BUILTINS) \
	snek-itsybitsy5v.builtin

include $(SNEK_ROOT)/snek-install.defs

all: $(ELF) $(HEX) snek-itsybitsy-install

$(PROG): Makefile $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $(SNEK_OBJ) $(LDFLAGS)
	@gawk '/__data_load_end/{printf("ROM used: %d bytes\n", strtonum($$1)); }' $(MAP)

snek-itsybitsy-install: snek-itsybitsy-install.in
	$(SNEK_SED) $^ > $@
	chmod +x $@

install:: $(HEX)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(HEX) $(DESTDIR)$(SHAREDIR)

install:: snek-itsybitsy-install snek-itsybitsy-install.1
	install -d $(DESTDIR)$(BINDIR)
	install snek-itsybitsy-install $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install -m 0644 snek-itsybitsy-install.1 $(DESTDIR)$(MANDIR)/man1

clean::
	rm -f snek-itsybitsy-install
	rm -f *.hex *.elf *.map
	rm -f ao-product.h

uninstall::

ISP=avrisp2

load: $(HEX) snek-itsybitsy-install
	./snek-itsybitsy-install -quick -isp $(ISP) -hex $(HEX) load

=== ports/mega/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..
SNEK_ATMEGA = $(SNEK_ROOT)/chips/atmega

include $(SNEK_ATMEGA)/snek-atmega.defs

SNEK_LOCAL_VPATH = $(SNEK_ATMEGA)

SNEK_LOCAL_SRC = \
	$(SNEK_ATMEGA_SRC) \
	$(SNEK_ATMEGA_MATH_SRC) \
	snek-input.c \
	snek-mega.c

SNEK_LOCAL_INC = \
	$(SNEK_ATMEGA_INC) \
	$(SNEK_ATMEGA_MATH_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_ATMEGA_BUILTINS) \
	$(SNEK_ATMEGA_MATH_BUILTINS) \
	snek-math.builtin \
	snek-input.builtin \
	snek-mega.builtin

include $(SNEK_ROOT)/snek-install.defs

SNEK_CFLAGS = $(SNEK_MOST_WARNINGS) $(SNEK_BASE_CFLAGS)

USBSERIAL_HEX=Arduino-usbserial-atmega16u2-Mega2560-Rev3.hex

BASE=snek-mega-$(SNEK_VERSION)
ELF=$(BASE).elf
HEX=$(BASE).hex
MAP=$(BASE).map
CC=avr-gcc
CFLAGS=-Os -DF_CPU=16000000UL -mmcu=atmega2560 -I. -I$(SNEK_LOCAL_VPATH) -g -fno-jump-tables $(SNEK_CFLAGS) -mcall-prologues -Waddr-space-convert
LDFLAGS=$(SNEK_LDFLAGS) \
	-Wl,-uvfprintf -lprintf_flt -lm \
	-Wl,--defsym -Wl,__TEXT_REGION_LENGTH__=0x3e000 \
	-Wl,--defsym -Wl,__DATA_REGION_LENGTH__=0x1e00 \
	-Wl,--defsym -Wl,__EEPROM_REGION_LENGTH__=0x1000 \
	-Wl,-Map=$(MAP)

PORT=/dev/ttyACM0

all: $(HEX) snek-mega-install

$(HEX): $(ELF)
	avr-objcopy -O ihex -R .eeprom $^ $@

$(ELF): $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)
	@gawk '/__data_load_end/{printf("ROM used: %d bytes\n", strtonum($$1)); }' $(MAP)

snek-mega-install: snek-mega-install.in
	$(SNEK_SED) $^ > $@
	chmod +x $@

load: $(HEX) snek-mega-install
	./snek-mega-install -port $(PORT) -hex $(HEX)

install: snek-mega-install $(HEX) $(USBSERIAL_HEX) snek-mega-install.1
	install -d $(DESTDIR)$(BINDIR)
	install snek-mega-install $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(HEX) $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(USBSERIAL_HEX) $(DESTDIR)$(SHAREDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install -m 0644 snek-mega-install.1 $(DESTDIR)$(MANDIR)/man1

clean::
	rm -f *.elf snek*.hex *.map snek-mega-install

load-direct: $(HEX)
	avrdude -patmega2560 -cwiring -P/dev/ttyACM0 -b115200 -D -Uflash:w:$(HEX):i

=== ports/uno/Makefile ===
#
# Copyright © 2020 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..
SNEK_ATMEGA = $(SNEK_ROOT)/chips/atmega

include $(SNEK_ATMEGA)/snek-atmega.defs

SNEK_LOCAL_VPATH = $(SNEK_ATMEGA)

SNEK_LOCAL_SRC = \
	snek-pow.c \
	snek-328p.c \
	$(SNEK_ATMEGA_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_ATMEGA_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_ATMEGA_BUILTINS) \
	snek-328p.builtin

include $(SNEK_ROOT)/snek-install.defs

USBSERIAL_HEX=Arduino-usbserial-atmega16u2-Uno-Rev3.hex

SNEK_CFLAGS = $(SNEK_MOST_WARNINGS) $(SNEK_BASE_CFLAGS) -DUART_BAUD=38400

BASE=snek-uno-$(SNEK_VERSION)
ELF=$(BASE).elf
HEX=$(BASE).hex
MAP=$(BASE).map
CC=avr-gcc

OPT=-Os -frename-registers -funsigned-char -fno-jump-tables -mcall-prologues

CFLAGS=$(OPT) -DF_CPU=16000000UL -mmcu=atmega328p -I. -I$(SNEK_LOCAL_VPATH) -g $(SNEK_CFLAGS) -Waddr-space-convert
LDFLAGS=$(SNEK_LDFLAGS) \
	-Wl,-uvfprintf -lprintf_flt -lm \
	-Wl,--defsym -Wl,__TEXT_REGION_LENGTH__=0x7e00 \
	-Wl,--defsym -Wl,__DATA_REGION_ORIGIN__=0x800100 \
	-Wl,--defsym -Wl,__DATA_REGION_LENGTH__=0x780 \
	-Wl,--defsym -Wl,__EEPROM_REGION_LENGTH__=0x400 \
	-Wl,-Map=$(MAP)

all: $(HEX) snek-uno-install

$(HEX): $(ELF)
	avr-objcopy -O ihex -R .eeprom $^ $@

$(ELF): $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)
	@gawk '/__data_load_end/{printf("ROM used: %d bytes\n", strtonum($$1)); }' $(MAP)

snek-uno-install: snek-uno-install.in
	$(SNEK_SED) $^ > $@
	chmod +x $@

load: $(HEX) snek-uno-install
	./snek-uno-install -hex $(HEX) snek

install: snek-uno-install $(HEX) snek-uno-install.1
	install -d $(DESTDIR)$(BINDIR)
	install snek-uno-install $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(HEX) $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(USBSERIAL_HEX) $(DESTDIR)$(SHAREDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install -m 0644 snek-uno-install.1 $(DESTDIR)$(MANDIR)/man1

clean::
	rm -f snek*.elf snek*.hex snek*.map snek-uno-install

=== doc/lessons/lesson-1/Makefile ===
SNEK_NO_BUILD_TARGETS = 1
SNEK_ROOT=../../..

include $(SNEK_ROOT)/snek-install.defs

.SUFFIXES: .adoc .pdf .html

ADOC_FILES=lesson-1-snekboard.adoc

PDF_FILES=$(ADOC_FILES:.adoc=.pdf)
HTML_FILES=$(ADOC_FILES:.adoc=.html)
CSS_FILES=snek.css
IMAGE_FILES=\
	snek.svg \
	mu-editor.png \
	mu-editor-serial.png \
	mu-editor-hello.png \
	snekboard-in-enclosure.jpg \
	snekboard-label.jpg \
	snekboard.svg \
	snekboard-sensors.jpg \
	snekboard-wired.jpg

THEME_FILE=snek-theme.yml

all: $(HTML_FILES) $(PDF_FILES)

LETTER_ATTRIBUTES=--attribute='pdf-style=snek' 
ATTRIBUTES=--attribute="revdate=$(SNEK_DATE)" --attribute="version=$(SNEK_VERSION)"

.adoc.html:
	asciidoctor -v $(ATTRIBUTES) -b html5 $*.adoc

.adoc.pdf:
	asciidoctor-pdf $(ATTRIBUTES) $(LETTER_ATTRIBUTES) $*.adoc

$(PDF_FILES): $(THEME_FILE) $(IMAGE_FILES)

$(HTML_FILES): snek.css

DOCFILES=$(PDF_FILES) $(HTML_FILES) $(CSS_FILES) $(IMAGE_FILES)

install: $(PDF_FILES)
	install -d $(DESTDIR)$(DOCDIR)/lessons
	for i in $(PDF_FILES); do install --mode=644 "$$i" $(DESTDIR)$(DOCDIR)/lessons || exit 1; done

upload: $(DOCFILES)
	rsync -avz $(DOCFILES) $(SNEK_ROOT)/doc/fonts $(SNEKDOC)/lessons/lesson-1

snek.css: $(SNEK_ROOT)/doc/snek.css
	cp $^ $@

snek.svg: $(SNEK_ROOT)/snek.svg
	cp $^ $@

snek-theme.yml: $(SNEK_ROOT)/doc/snek-theme.yml
	cp $^ $@

clean::
	rm -f $(PDF_FILES) $(HTML_FILES) $(BOOK_FILES)
	rm -f snek.css
	rm -f snek.svg snek-theme.yml

=== doc/lessons/lesson-2/Makefile ===
SNEK_NO_BUILD_TARGETS = 1
SNEK_ROOT=../../..

include $(SNEK_ROOT)/snek-install.defs

.SUFFIXES: .adoc .pdf .html

ADOC_FILES=lesson-2-line-bug.adoc

PDF_FILES=$(ADOC_FILES:.adoc=.pdf)
HTML_FILES=$(ADOC_FILES:.adoc=.html)
CSS_FILES=snek.css  coderay-asciidoctor.css
IMAGE_FILES=\
	line-bug.svg \
	21980.dat.png \
	22253c02.dat.png \
	2654.dat.png \
	3001.dat.png \
	32073.dat.png \
	3647.dat.png \
	3648b.dat.png \
	3713.dat.png \
	3738.dat.png \
	3895.dat.png \
	3956.dat.png \
	4459.dat.png \
	4519.dat.png \
	6590.dat.png \
	Line-Bug-01.png \
	Line-Bug-02.png \
	Line-Bug-03.png \
	Line-Bug-04.png \
	Line-Bug-05.png \
	Line-Bug-06.png \
	Line-Bug-07.png \
	Line-Bug-08.png \
	Line-Bug-09.png \
	Line-Bug-10.png \
	Line-Bug-11.png \
	Line-Bug-12.png \
	Line-Bug-13.png \
	Line-Bug-14.png \
	Line-Bug-15.png \
	Line-Bug-16.png \
	left-turn.svg \
	right-turn.svg

INC_FILES=steps.adoc

THEME_FILE=snek-theme.yml

all: $(HTML_FILES) $(PDF_FILES) $(CSS_FILES) snek.svg snek.css

LETTER_ATTRIBUTES=--attribute='pdf-style=snek' 
ATTRIBUTES=--attribute="revdate=$(SNEK_DATE)" --attribute="version=$(SNEK_VERSION)"

.adoc.html:
	asciidoctor -v -B$(SNEK_ROOT) -B. $(ATTRIBUTES) -b html5 $*.adoc

.adoc.pdf:
	asciidoctor-pdf -B$(SNEK_ROOT) -B. $(ATTRIBUTES) $(LETTER_ATTRIBUTES) $*.adoc

$(PDF_FILES): $(THEME_FILE) $(IMAGE_FILES) $(INC_FILES) snek.svg

DOCFILES=$(PDF_FILES) $(HTML_FILES) $(CSS_FILES) snek.svg $(IMAGE_FILES)

$(HTML_FILES): $(INC_FILES)

install: $(PDF_FILES)
	install -d $(DESTDIR)$(DOCDIR)/lessons
	for i in $(PDF_FILES); do install --mode=644 "$$i" $(DESTDIR)$(DOCDIR)/lessons || exit 1; done

upload: $(DOCFILES)
	rsync -avz $(DOCFILES) $(SNEK_ROOT)/doc/fonts $(SNEKDOC)/lessons/lesson-2/

steps.adoc: $(SNEK_DOC_UTIL)/make-step $(SNEK_DOC_UTIL)/make-steps
	$(SNEK_DOC_UTIL)/make-steps Line-Bug-??.html > $@

snek.css: $(SNEK_DOC)/snek.css
	cp $^ $@

snek.svg: $(SNEK_ROOT)/snek.svg
	cp $^ $@

snek-theme.yml: $(SNEK_ROOT)/doc/snek-theme.yml
	cp $^ $@

coderay-asciidoctor.css: $(HTML_FILES)

clean::
	rm -f $(PDF_FILES) $(HTML_FILES) $(BOOK_FILES) coderay-asciidoctor.css
	rm -f Line-Bug-??.adoc steps.adoc
	rm -f snek.css snek.svg snek-theme.yml

=== debian/changelog ===
snek (1.5-1) unstable; urgency=medium

  * New upstream release.
  * Arduino Uno port
  * Handle 'chained' comparison operators (e.g. a > b > c)
  * Stop using black during build. Closes: #971143.

 -- Keith Packard <keithp@keithp.com>  Tue, 06 Oct 2020 16:17:33 -0700

=== debian/control ===
--- 
+++ 
@@ -2,16 +2,17 @@
 Section: interpreters
 Priority: optional
 Maintainer: Keith Packard <keithp@keithp.com>
-Homepage: https://keithp.com
 Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13), libreadline-dev, python3, lola, gawk
 Build-Depends-Indep: avr-libc, gcc-avr,
  binutils-arm-none-eabi, gcc-arm-none-eabi, picolibc-arm-none-eabi (>= 1.4), qemu-system-arm,
  binutils-riscv64-unknown-elf, gcc-riscv64-unknown-elf, picolibc-riscv64-unknown-elf (>= 1.4),
  gcc-arm-linux-gnueabi, libc6-dev-armel-cross,
- asciidoctor, ruby-asciidoctor-pdf, ruby-coderay,
- black
+ asciidoctor, ruby-asciidoctor-pdf, ruby-coderay
 Standards-Version: 4.5.0
+HomePage: https://sneklang.org
+Vcs-Git: git://sneklang.org/git/snek.git
+Vcs-Browser: https://sneklang.org/cgit/snek.git
 
 Package: snek
 Architecture: all

=== debian/tests/control ===
Test-Command: make SNEK_NATIVE=/usr/bin/snek SNEK_ARM=/usr/share/snek/snek-arm -C test check
Depends: @, qemu-system-arm, gcc
